package limax.codec;

import java.security.MessageDigest;

abstract class MD extends Codec {
	private final Codec sink;
	private byte oneByte[] = new byte[1];
	protected MessageDigest md;

	public MD(Codec sink) {
		this.sink = sink;
	}

	@Override
	public void update(byte c) throws CodecException {
		oneByte[0] = c;
		md.update(oneByte, 0, 1);
		sink.update(c);
	}

	@Override
	public void update(byte[] data, int off, int len) throws CodecException {
		md.update(data, off, len);
		sink.update(data, off, len);
	}

	@Override
	public void flush() throws CodecException {
		sink.flush();
	}

	public byte[] digest() {
		return md.digest();
	}
}
